# Cartesian4

#### new Cesium.Cartesian4(x, y, z, w)
Core/Cartesian4.js 21

A 4D Cartesian point.

Name | Type | Default | Description
--- | --- | --- | ---
`x` | Number | `0.0` | optional The X component.
`y` | Number | `0.0` | optional The Y component.
`z` | Number | `0.0` | optional The Z component.
`w` | Number | `0.0` | optional The W component.

##### See:

- Cartesian2
- Cartesian3
- Packable

### Members

#### w : Number
Core/Cartesian4.js 48

The W component.

Default Value: `0.0`

#### x : Number
Core/Cartesian4.js 27

The X component.

Default Value: `0.0`

#### y : Number
Core/Cartesian4.js 34

The Y component.

Default Value: `0.0`

#### z : Number
Core/Cartesian4.js 41

The Z component.

Default Value: `0.0`

#### static Cesium.Cartesian4.packedLength : Number
Core/Cartesian4.js 123

The number of elements used to pack the object into an array.

#### static constant Cesium.Cartesian4.UNIT_W : Cartesian4
Core/Cartesian4.js 765

An immutable Cartesian4 instance initialized to (0.0, 0.0, 0.0, 1.0).

#### static constant Cesium.Cartesian4.UNIT_X : Cartesian4
Core/Cartesian4.js 741

An immutable Cartesian4 instance initialized to (1.0, 0.0, 0.0, 0.0).

#### static constant Cesium.Cartesian4.UNIT_Y : Cartesian4
Core/Cartesian4.js 749

An immutable Cartesian4 instance initialized to (0.0, 1.0, 0.0, 0.0).

#### static constant Cesium.Cartesian4.UNIT_Z : Cartesian4
Core/Cartesian4.js 757

An immutable Cartesian4 instance initialized to (0.0, 0.0, 1.0, 0.0).

#### static constant Cesium.Cartesian4.ZERO : Cartesian4
Core/Cartesian4.js 733

An immutable Cartesian4 instance initialized to (0.0, 0.0, 0.0, 0.0).

### Methods

#### clone(result) → Cartesian4
Core/Cartesian4.js 773

Duplicates this Cartesian4 instance.

Name | Type | Description
--- | --- | ---
`result` | Cartesian4 | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Cartesian4 instance if one was not provided.

#### equals(right) → Boolean
Core/Cartesian4.js 784

Compares this Cartesian against the provided Cartesian componentwise and returns `true` if they are equal, `false` otherwise.

Name | Type | Description
--- | --- | ---
`right` | Cartesian4 | optional The right hand side Cartesian.

##### Returns:

`true` if they are equal, `false` otherwise.

#### equalsEpsilon(right, relativeEpsilon, absoluteEpsilon) → Boolean
Core/Cartesian4.js 798

Compares this Cartesian against the provided Cartesian componentwise and returns `true` if they pass an absolute or relative tolerance test, `false` otherwise.

Name | Type | Default | Description
--- | --- | --- | ---
`right` | Cartesian4 |  | optional The right hand side Cartesian.
`relativeEpsilon` | Number | `0` | optional The relative epsilon tolerance to use for equality testing.
`absoluteEpsilon` | Number | `relativeEpsilon` | optional The absolute epsilon tolerance to use for equality testing.

##### Returns:

`true` if they are within the provided epsilon, `false` otherwise.

#### toString() → String
Core/Cartesian4.js 807

Creates a string representing this Cartesian in the format '(x, y, z, w)'.

##### Returns:

A string representing the provided Cartesian in the format '(x, y, z, w)'.

#### static Cesium.Cartesian4.abs(cartesian, result) → Cartesian4
Core/Cartesian4.js 605

Computes the absolute value of the provided Cartesian.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian whose absolute value is to be computed.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.add(left, right, result) → Cartesian4
Core/Cartesian4.js 498

Computes the componentwise sum of two Cartesians.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | The first Cartesian.
`right` | Cartesian4 | The second Cartesian.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.clone(cartesian, result) → Cartesian4
Core/Cartesian4.js 103

Duplicates a Cartesian4 instance.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian to duplicate.
`result` | Cartesian4 | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Cartesian4 instance if one was not provided. (Returns undefined if cartesian is undefined)

#### static Cesium.Cartesian4.distance(left, right) → Number
Core/Cartesian4.js 367

Computes the 4-space distance between two points.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | The first point to compute the distance from.
`right` | Cartesian4 | The second point to compute the distance to.

##### Returns:

The distance between two points.

##### Example:

    // Returns 1.0
    var d = Cesium.Cartesian4.distance(
      new Cesium.Cartesian4(1.0, 0.0, 0.0, 0.0),
      new Cesium.Cartesian4(2.0, 0.0, 0.0, 0.0));

#### static Cesium.Cartesian4.distanceSquared(left, right) → Number
Core/Cartesian4.js 391

Computes the squared distance between two points. Comparing squared distances using this function is more efficient than comparing distances using `Cartesian4#distance`.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | The first point to compute the distance from.
`right` | Cartesian4 | The second point to compute the distance to.

##### Returns:

The distance between two points.

##### Example:

    // Returns 4.0, not 2.0
    var d = Cesium.Cartesian4.distance(
      new Cesium.Cartesian4(1.0, 0.0, 0.0, 0.0),
      new Cesium.Cartesian4(3.0, 0.0, 0.0, 0.0));

#### static Cesium.Cartesian4.divideByScalar(cartesian, scalar, result) → Cartesian4
Core/Cartesian4.js 564

Divides the provided Cartesian componentwise by the provided scalar.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian to be divided.
`scalar` | Number | The scalar to divide by.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.divideComponents(left, right, result) → Cartesian4
Core/Cartesian4.js 476

Computes the componentwise quotient of two Cartesians.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | The first Cartesian.
`right` | Cartesian4 | The second Cartesian.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.dot(left, right) → Number
Core/Cartesian4.js 437

Computes the dot (scalar) product of two Cartesians.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | The first Cartesian.
`right` | Cartesian4 | The second Cartesian.

##### Returns:

The dot product.

#### static Cesium.Cartesian4.equals(left, right) → Boolean
Core/Cartesian4.js 693

Compares the provided Cartesians componentwise and returns `true` if they are equal, `false` otherwise.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | optional The first Cartesian.
`right` | Cartesian4 | optional The second Cartesian.

##### Returns:

`true` if left and right are equal, `false` otherwise.

#### static Cesium.Cartesian4.equalsEpsilon(left, right, relativeEpsilon, absoluteEpsilon) → Boolean
Core/Cartesian4.js 715

Compares the provided Cartesians componentwise and returns `true` if they pass an absolute or relative tolerance test, `false` otherwise.

Name | Type | Default | Description
--- | --- | --- | ---
`left` | Cartesian4 |  | optional The first Cartesian.
`right` | Cartesian4 |  | optional The second Cartesian.
`relativeEpsilon` | Number | `0` | optional The relative epsilon tolerance to use for equality testing.
`absoluteEpsilon` | Number | `relativeEpsilon` | optional The absolute epsilon tolerance to use for equality testing.

##### Returns:

`true` if left and right are within the provided epsilon, `false` otherwise.

#### static Cesium.Cartesian4.fromArray(array, startingIndex, result) → Cartesian4
Core/Cartesian4.js 252

Creates a Cartesian4 from four consecutive elements in an array.

Name | Type | Default | Description
--- | --- | --- | ---
`array` | Array.<Number> |  | The array whose four consecutive elements correspond to the x, y, z, and w components, respectively.
`startingIndex` | Number | `0` | optional The offset into the array of the first element, which corresponds to the x component.
`result` | Cartesian4 |  | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Cartesian4 instance if one was not provided.

##### Example:

    // Create a Cartesian4 with (1.0, 2.0, 3.0, 4.0)
    var v = [1.0, 2.0, 3.0, 4.0];
    var p = Cesium.Cartesian4.fromArray(v);

    // Create a Cartesian4 with (1.0, 2.0, 3.0, 4.0) using an offset into an array
    var v2 = [0.0, 0.0, 1.0, 2.0, 3.0, 4.0];
    var p2 = Cesium.Cartesian4.fromArray(v2, 2);

#### static Cesium.Cartesian4.fromColor(color, result) → Cartesian4
Core/Cartesian4.js 81

Creates a Cartesian4 instance from a `Color`. `red`, `green`, `blue`, and `alpha` map to `x`, `y`, `z`, and `w`, respectively.

Name | Type | Description
--- | --- | ---
`color` | Color | The source color.
`result` | Cartesian4 | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Cartesian4 instance if one was not provided.

#### static Cesium.Cartesian4.fromElements(x, y, z, w, result) → Cartesian4
Core/Cartesian4.js 61

Creates a Cartesian4 instance from x, y, z and w coordinates.

Name | Type | Description
--- | --- | ---
`x` | Number | The x coordinate.
`y` | Number | The y coordinate.
`z` | Number | The z coordinate.
`w` | Number | The w coordinate.
`result` | Cartesian4 | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new Cartesian4 instance if one was not provided.

#### static Cesium.Cartesian4.lerp(start, end, t, result) → Cartesian4
Core/Cartesian4.js 628

Computes the linear interpolation or extrapolation at t using the provided cartesians.

Name | Type | Description
--- | --- | ---
`start` | Cartesian4 | The value corresponding to t at 0.0.
`end` | Cartesian4 | The value corresponding to t at 1.0.
`t` | Number | The point along t at which to interpolate.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.magnitude(cartesian) → Number
Core/Cartesian4.js 348

Computes the Cartesian's magnitude (length).

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian instance whose magnitude is to be computed.

##### Returns:

The magnitude.

#### static Cesium.Cartesian4.magnitudeSquared(cartesian) → Number
Core/Cartesian4.js 334

Computes the provided Cartesian's squared magnitude.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian instance whose squared magnitude is to be computed.

##### Returns:

The squared magnitude.

#### static Cesium.Cartesian4.maximumByComponent(first, second, result) → Cartesian4
Core/Cartesian4.js 313

Compares two Cartesians and computes a Cartesian which contains the maximum components of the supplied Cartesians.

Name | Type | Description
--- | --- | ---
`first` | Cartesian4 | A cartesian to compare.
`second` | Cartesian4 | A cartesian to compare.
`result` | Cartesian4 | The object into which to store the result.

##### Returns:

A cartesian with the maximum components.

#### static Cesium.Cartesian4.maximumComponent(cartesian) → Number
Core/Cartesian4.js 260

Computes the value of the maximum component for the supplied Cartesian.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The cartesian to use.

##### Returns:

The value of the maximum component.

#### static Cesium.Cartesian4.minimumByComponent(first, second, result) → Cartesian4
Core/Cartesian4.js 290

Compares two Cartesians and computes a Cartesian which contains the minimum components of the supplied Cartesians.

Name | Type | Description
--- | --- | ---
`first` | Cartesian4 | A cartesian to compare.
`second` | Cartesian4 | A cartesian to compare.
`result` | Cartesian4 | The object into which to store the result.

##### Returns:

A cartesian with the minimum components.

#### static Cesium.Cartesian4.minimumComponent(cartesian) → Number
Core/Cartesian4.js 274

Computes the value of the minimum component for the supplied Cartesian.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The cartesian to use.

##### Returns:

The value of the minimum component.

#### static Cesium.Cartesian4.mostOrthogonalAxis(cartesian, result) → Cartesian4
Core/Cartesian4.js 649

Returns the axis that is most orthogonal to the provided Cartesian.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian on which to find the most orthogonal axis.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The most orthogonal axis.

#### static Cesium.Cartesian4.multiplyByScalar(cartesian, scalar, result) → Cartesian4
Core/Cartesian4.js 542

Multiplies the provided Cartesian componentwise by the provided scalar.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian to be scaled.
`scalar` | Number | The scalar to multiply with.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.multiplyComponents(left, right, result) → Cartesian4
Core/Cartesian4.js 454

Computes the componentwise product of two Cartesians.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | The first Cartesian.
`right` | Cartesian4 | The second Cartesian.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.negate(cartesian, result) → Cartesian4
Core/Cartesian4.js 585

Negates the provided Cartesian.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian to be negated.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.normalize(cartesian, result) → Cartesian4
Core/Cartesian4.js 408

Computes the normalized form of the supplied Cartesian.

Name | Type | Description
--- | --- | ---
`cartesian` | Cartesian4 | The Cartesian to be normalized.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.pack(value, array, startingIndex) → Array.<Number>
Core/Cartesian4.js 134

Stores the provided instance into the provided array.

Name | Type | Default | Description
--- | --- | --- | ---
`value` | Cartesian4 |  | The value to pack.
`array` | Array.<Number> |  | The array to pack into.
`startingIndex` | Number | `0` | optional The index into the array at which to start packing the elements.

##### Returns:

The array that was packed into

#### static Cesium.Cartesian4.packArray(array, result) → Array.<Number>
Core/Cartesian4.js 183

Flattens an array of Cartesian4s into and array of components.

Name | Type | Description
--- | --- | ---
`array` | Array.<Cartesian4> | The array of cartesians to pack.
`result` | Array.<Number> | optional The array onto which to store the result. If this is a typed array, it must have array.length * 4 components, else a `DeveloperError` will be thrown. If it is a regular array, it will be resized to have (array.length * 4) elements.

##### Returns:

The packed array.

#### static Cesium.Cartesian4.packFloat(value, result) → Cartesian4
Core/Cartesian4.js 826

Packs an arbitrary floating point value to 4 values representable using uint8.

Name | Type | Description
--- | --- | ---
`value` | Number | A floating point number.
`result` | Cartesian4 | optional The Cartesian4 that will contain the packed float.

##### Returns:

A Cartesian4 representing the float packed to values in x, y, z, and w.

#### static Cesium.Cartesian4.subtract(left, right, result) → Cartesian4
Core/Cartesian4.js 520

Computes the componentwise difference of two Cartesians.

Name | Type | Description
--- | --- | ---
`left` | Cartesian4 | The first Cartesian.
`right` | Cartesian4 | The second Cartesian.
`result` | Cartesian4 | The object onto which to store the result.

##### Returns:

The modified result parameter.

#### static Cesium.Cartesian4.unpack(array, startingIndex, result) → Cartesian4
Core/Cartesian4.js 158

Retrieves an instance from a packed array.

Name | Type | Default | Description
--- | --- | --- | ---
`array` | Array.<Number> |  | The packed array.
`startingIndex` | Number | `0` | optional The starting index of the element to be unpacked.
`result` | Cartesian4 |  | optional The object into which to store the result.

##### Returns:

The modified result parameter or a new Cartesian4 instance if one was not provided.

#### static Cesium.Cartesian4.unpackArray(array, result) → Array.<Cartesian4>
Core/Cartesian4.js 211

Unpacks an array of cartesian components into and array of Cartesian4s.

Name | Type | Description
--- | --- | ---
`array` | Array.<Number> | The array of components to unpack.
`result` | Array.<Cartesian4> | optional The array onto which to store the result.

##### Returns:

The unpacked array.